<template>
    <div>
        <v-list>
            <v-list-tile v-if="adminAndOperationalPrivileges"
                id="sideBarMenuListItem">
                <router-link to="/home/report"
                    class="sidebarMenuLink">
                    <v-list-tile-title class="menuListItemText">
                        <v-icon class="sideBarMenuListItemIcon colorWhite">
                            insert_chart
                        </v-icon>
                        <span class="sideBarMenuListItemText colorWhite">
                            Report
                        </span>
                    </v-list-tile-title>
                </router-link>
            </v-list-tile>
            <v-divider></v-divider>
            <v-list-tile id="sideBarMenuListItem" >
                <router-link to="/home/sales"
                    class="sidebarMenuLink">
                    <v-list-tile-title class="menuListItemText">
                        <v-icon class="sideBarMenuListItemIcon colorWhite">
                            attach_money
                        </v-icon>
                        <span class="sideBarMenuListItemText colorWhite">
                            Sales
                        </span>
                    </v-list-tile-title>
                </router-link>
            </v-list-tile>
            <v-divider></v-divider>
            <v-list-group light
                v-if="itemViewMenuShow">
                <v-list-tile slot="activator">
                    <v-list-tile-content>
                        <v-list-tile-action>
                            <v-icon class="colorWhite">
                                casino
                            </v-icon>
                        </v-list-tile-action>
                    </v-list-tile-content>
                    <v-list-tile-title class="colorWhite">
                        Item
                    </v-list-tile-title>
                </v-list-tile>
              <div style="background:#375865;padding-top:5px;border-top:1px solid #BDBDBD;">
                  <router-link to="/home/item_add"
                    class="sidebarMenuLink">
                    <v-btn depressed
                        v-if="itemAddMenuShow"
                        block
                        small
                        color="lightBlueBackground"
                        style="display:block;width:90%;margin: 0px auto 5px auto;">
                        ADD ITEMS
                    </v-btn>
                  </router-link>
                  <div class="sidebarListContainer">
                    <v-progress-circular
                        v-if="updateAllItems"
                        :size="40"
                        :width="3"
                        indeterminate
                        color="lightBackground"
                        style="display:block;margin:20px auto;">
                    </v-progress-circular>
                    <v-list-tile v-if="!updateAllItems"
                        v-for="item in itemList"
                        :key="item"
                        id="sideBarMenuListItem" >
                        <router-link :to="{name:'item_view',params:{id:item}}"
                            class="sidebarMenuLink">
                            <v-list-tile-title class="menuListItemText">
                                <span class="sideBarMenuListItemText colorWhite">
                                    {{ item }}
                                </span>
                            </v-list-tile-title>
                        </router-link>
                    </v-list-tile>
               </div>
            </div>
            </v-list-group>
            <v-divider></v-divider>
            <v-list-group v-if="adminAndOperationalPrivileges">
                <v-list-tile slot="activator">
                    <v-list-tile-content>
                        <v-list-tile-action>
                            <v-icon class="colorWhite">
                                people
                            </v-icon>
                        </v-list-tile-action>
                    </v-list-tile-content>
                    <v-list-tile-title class="colorWhite">
                        Seller
                    </v-list-tile-title>
                </v-list-tile>
              <div style="background:#375865;padding-top:5px;border-top:1px solid #BDBDBD;">
                <router-link to="/home/seller_add"
                class="sidebarMenuLink">
                    <v-btn depressed
                        block
                        small
                        color="lightBlueBackground"
                        style="display:block;width:90%;margin: 0px auto 5px auto;">
                        ADD SELLER
                    </v-btn>
                </router-link>
               <div class="sidebarListContainer">
                    <v-progress-circular
                        v-if="updateAllSellers"
                        :size="40"
                        :width="3"
                        indeterminate
                        color="lightBackground"
                        style="display:block;margin:20px auto;">
                    </v-progress-circular>
                    <v-list-tile v-if="!updateAllSellers"
                        v-for="seller in fullSellerName"
                        :key="seller"
                        id="sideBarMenuListItem" >
                        <router-link :to="{name:'seller_view',params:{id:seller}}"
                            class="sidebarMenuLink">
                            <v-list-tile-title class="menuListItemText">
                                <span class="sideBarMenuListItemText colorWhite">
                                    {{ seller }}
                                </span>
                            </v-list-tile-title>
                        </router-link>
                    </v-list-tile>
               </div>
              </div>
            </v-list-group>
            <v-divider></v-divider>
            <v-list-group v-if="adminAndOperationalPrivileges">
                <v-list-tile slot="activator">
                    <v-list-tile-content>
                        <v-list-tile-action>
                            <v-icon class="colorWhite">
                                person
                            </v-icon>
                        </v-list-tile-action>
                    </v-list-tile-content>
                    <v-list-tile-title class="colorWhite">
                        User
                    </v-list-tile-title>
                </v-list-tile>
              <div style="background:#375865;padding-top:5px;border-top:1px solid #BDBDBD;">
                <router-link to="/home/user_add"
                    class="sidebarMenuLink">
                    <v-btn depressed
                        block
                        small
                        color="lightBlueBackground"
                        style="display:block;width:90%;margin: 0px auto 5px auto;">
                        ADD USER
                    </v-btn>
                </router-link>
               <div class="sidebarListContainer">
                    <v-progress-circular
                        v-if="updateAllUsers"
                        :size="40"
                        :width="3"
                        indeterminate
                        color="lightBackground"
                        style="display:block;margin:20px auto;">
                    </v-progress-circular>
                    <v-list-tile v-if="!updateAllUsers"
                        v-for="user in userList"
                        :key="user"
                        id="sideBarMenuListItem" >
                        <router-link :to="{name:'user_view',params:{id:user}}"
                            class="sidebarMenuLink">
                            <v-list-tile-title class="menuListItemText">
                                <span class="sideBarMenuListItemText colorWhite">
                                    {{ user }}
                                </span>
                            </v-list-tile-title>
                        </router-link>
                    </v-list-tile>
               </div>
              </div>
            </v-list-group>
            <v-divider></v-divider>
            <v-list-tile id="sideBarMenuListItem"
                v-if="adminAndOperationalPrivileges">
                <router-link
                    to="/home/store"
                    class="sidebarMenuLink">
                    <v-list-tile-title class="menuListItemText">
                        <v-icon class="sideBarMenuListItemIcon colorWhite">
                            store
                        </v-icon>
                        <span class="sideBarMenuListItemText colorWhite">
                            Store
                        </span>
                    </v-list-tile-title>
                </router-link>
            </v-list-tile>
            <v-divider></v-divider>
            <v-list-tile id="sideBarMenuListItem"
                v-if="adminAndOperationalPrivileges">
                <router-link to="/home/stock"
                    class="sidebarMenuLink">
                    <v-list-tile-title class="menuListItemText">
                        <v-icon class="sideBarMenuListItemIcon colorWhite">
                            store
                        </v-icon>
                        <span class="sideBarMenuListItemText colorWhite">
                            Stock
                        </span>
                    </v-list-tile-title>
                </router-link>
            </v-list-tile>
        </v-list>
          <v-snackbar
            :timeout="timeout"
            :top="y === 'top'"
            :bottom="y === 'bottom'"
            :right="x === 'right'"
            :left="x === 'left'"
            :multi-line="mode === 'multi-line'"
            :vertical="mode === 'vertical'"
            v-model="snackbar"
            color="error">
            {{ errorText }}
            <v-btn flat
                color="white"
                @click.native="snackbar = false">
                Close
            </v-btn>
        </v-snackbar>
    </div>
</template>
<script>
import axios from 'axios'
export default {
  name: 'DrawerComponent',
  data: () => ({
    itemList: [],
    sellerList: [],
    userList: [],
    errorText: '',
    snackbar: false,
    y: 'top',
    x: 'left',
    mode: '',
    timeout: 6000,
    loadingItemsData: true,
    loadingSellersData: true,
    loadingUsersData: true,
    itemsDataReturned: false,
    sellersDataReturned: false,
    UsersDataReturned: false
  }),
  computed: {
    fullSellerName () {
      return this.sellerList.map(element => {
        return element.firstName + ' ' + element.lastName
      })
    },
    updateAllItems () {
      return this.$store.state.homeModule.getAllItemList
    },
    updateAllSellers () {
      return this.$store.state.homeModule.getAllSellerList
    },
    updateAllUsers () {
      return this.$store.state.homeModule.getAllUserList
    },
    adminAndOperationalPrivileges () {
      let userType = this.$store.state.userType
      if (userType === 'SALES') {
        return false
      } else {
        return true
      }
    },
    itemAddMenuShow () {
      let userType = this.$store.state.userType
      if (userType === 'ADMIN') {
        return true
      } else {
        return false
      }
    },
    itemViewMenuShow () {
      let userType = this.$store.state.userType
      if (userType === 'SALES') {
        return false
      } else {
        return true
      }
    }
  },
  watch: {
    updateAllItems (val) {
      if (val === true) {
        axios.get('/all_item_names')
          .then(response => {
            this.itemList = response.data
            this.$store.commit('ITEMS_LIST_UPDATED')
          }, error => {
            this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error in getting all items list: ' + error)
          })
      }
    },
    updateAllSellers (val) {
      if (val === true) {
        axios.get('/get_all_seller_names')
          .then(response => {
            this.sellerList = response.data
            this.$store.commit('SELLERS_LIST_UPDATED')
          }, error => {
            this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error in getting all sellers list: ' + error)
          })
      }
    },
    updateAllUsers (val) {
      if (val === true) {
        axios.get('/get_all_user_names')
          .then(response => {
            this.userList = response.data
            this.$store.commit('USERS_LIST_UPDATED')
          }, error => {
            this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error in getting all sellers list: ' + error)
          })
      }
    }
  },
  created () {
    axios.get('/all_item_names')
      .then(response => {
        this.itemList = response.data
        this.$store.commit('ITEMS_LIST_UPDATED')
        return axios.get('/get_all_seller_names')
      }, error => {
        this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error in getting all items list: ' + error)
        return axios.get('/get_all_seller_names')
      })
      .then(response => {
        this.sellerList = response.data
        this.$store.commit('SELLERS_LIST_UPDATED')
        return axios.get('/get_all_user_names')
      }, error => {
        this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error in getting all sellers list: ' + error)
        return axios.get('/get_all_user_names')
      })
      .then(response => {
        this.userList = response.data
        this.$store.commit('USERS_LIST_UPDATED')
      }, error => {
        this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error in getting all users list: ' + error)
      })
  }
}
</script>

<style>
.sidebarListContainer{
    height:auto;
    max-height:200px;
    overflow-y:auto;
}
.sidebarMenuLink{
    text-decoration: none;
    outline: none;
    color: rgba(0,0,0,.87);
    width: 100%;
}
#sideBarMenuListItem,
#sideBarMenuListItemSales{
    background: transparent;
    padding: 0px !important;
    border-bottom: none;
}
#sideBarMenuListItem:hover,
#sideBarMenuListItemSales:hover{
    background: rgba(0,0,0,.15);
}
.router-link-active{
    background: #2b8ba3;
    padding: 12px 0;
    height: 48px;
    box-shadow: 7px 0px 0px inset #ff9100;
}
.menuListItemIcon,
.menuListItemText{
    float: left;
}
.sideBarMenuListItemText,.sideBarMenuListItemIcon{
    padding-left: 17px;
}
.colorWhite {
    color: #FFFFFF !important;
}
</style>
